/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blockentity.storage.lesu;

import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import reborncore.api.IToolDrop;
import reborncore.common.blockentity.MachineBaseBlockEntity;
import techreborn.init.TRContent;
import techreborn.init.TRBlockEntities;

public class LSUStorageBlockEntity extends MachineBaseBlockEntity
	implements IToolDrop {

	public LesuNetwork network;

	public LSUStorageBlockEntity() {
		super(TRBlockEntities.LSU_STORAGE);
	}

	public final void findAndJoinNetwork(class_1937 world, int x, int y, int z) {
		network = new LesuNetwork();
		network.addElement(this);
		for (class_2350 direction : class_2350.values()) {
			if (world.method_8321(new class_2338(x + direction.method_10148(), y + direction.method_10164(),
					z + direction.method_10165())) instanceof LSUStorageBlockEntity) {
				LSUStorageBlockEntity lesu = (LSUStorageBlockEntity) world.method_8321(new class_2338(x + direction.method_10148(),
				                                                                                       y + direction.method_10164(), z + direction.method_10165()));
				if (lesu.network != null) {
					lesu.network.merge(network);
				}
			}
		}
	}

	public final void setNetwork(LesuNetwork n) {
		if (n == null) {
		} else {
			network = n;
			network.addElement(this);
		}
	}

	public final void resetNetwork() {
		network = null;
	}

	public final void removeFromNetwork() {
		if (network == null) {
		} else
			network.removeElement(this);
	}

	public final void rebuildNetwork() {
		removeFromNetwork();
		resetNetwork();
		findAndJoinNetwork(field_11863, field_11867.method_10263(), field_11867.method_10264(), field_11867.method_10260());
	}

	// TileMachineBase
	@Override
	public void method_16896() {
		super.method_16896();
		if (network == null) {
			findAndJoinNetwork(field_11863, field_11867.method_10263(), field_11867.method_10264(), field_11867.method_10260());
		} else {
			if (network.master != null
					&& network.master.method_10997().method_8321(new class_2338(network.master.method_11016().method_10263(),
							network.master.method_11016().method_10264(), network.master.method_11016().method_10260())) != network.master) {
				network.master = null;
			}
		}
	}

	// IToolDrop
	@Override
	public class_1799 getToolDrop(class_1657 entityPlayer) {
		return TRContent.Machine.LSU_STORAGE.getStack();
	}
}
