/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.client.gui;

import net.minecraft.class_1657;
import reborncore.client.containerBuilder.builder.BuiltContainer;
import reborncore.client.gui.builder.GuiBase;
import reborncore.client.gui.guibuilder.GuiBuilder;
import techreborn.blockentity.machine.iron.IronAlloyFurnaceBlockEntity;

public class GuiAlloyFurnace extends GuiBase<BuiltContainer> {

	IronAlloyFurnaceBlockEntity blockEntity;

	public GuiAlloyFurnace(int syncID, class_1657 player, IronAlloyFurnaceBlockEntity alloyFurnace) {
		super(player, alloyFurnace, alloyFurnace.createContainer(syncID, player));
		this.blockEntity = alloyFurnace;
	}

	@Override
	protected void method_2389(float lastFrameDuration, int mouseX, int mouseY) {
		super.method_2389(lastFrameDuration, mouseX, mouseY);
		GuiBase.Layer layer = GuiBase.Layer.BACKGROUND;

		// Input slots
		drawSlot(47, 17, layer);
		drawSlot(65, 17, layer);
		// Fuel slot
		drawSlot(56, 53, layer);

		drawOutputSlot(116, 35, layer);
	}

	@Override
	protected void method_2388(int mouseX, int mouseY) {
		super.method_2388(mouseX, mouseY);
		GuiBase.Layer layer = GuiBase.Layer.FOREGROUND;

		builder.drawProgressBar(this, blockEntity.getProgressScaled(100), 100, 85, 36, mouseX, mouseY, GuiBuilder.ProgressDirection.RIGHT, layer);
		builder.drawBurnBar(this, blockEntity.getBurnTimeRemainingScaled(100), 100, 56, 36, mouseX, mouseY, layer);
	}
}
