/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.utils;

import net.fabricmc.fabric.api.event.client.ItemTooltipCallback;
import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2248;
import net.minecraft.class_2487;
import net.minecraft.class_2519;
import net.minecraft.class_2585;
import reborncore.common.util.StringUtils;
import techreborn.init.TRContent;

import java.util.ArrayList;

/**
 * Created by Mark on 23/03/2016.
 */
public class StackWIPHandler {
	private static ArrayList<class_2248> wipBlocks = new ArrayList<>();
	public static ArrayList<class_1799> devHeads = new ArrayList<>();

	public static void setup() {
		wipBlocks.add(TRContent.Machine.MAGIC_ENERGY_ABSORBER.block);
		wipBlocks.add(TRContent.Machine.MAGIC_ENERGY_CONVERTER.block);

		addHead("modmuss50");
		addHead("Gigabit101");
		addHead("ProfProspector");
		addHead("Rushmead");

		ItemTooltipCallback.EVENT.register((stack, tooltipContext, components) -> {
			class_2248 block = class_2248.method_9503(stack.method_7909());
			if (block != null && wipBlocks.contains(block)) {
				components.add(new class_2585(class_124.field_1061 + StringUtils.t("techreborn.tooltip.wip")));
			}

			if (devHeads.contains(stack)) {
				components.add(new class_2585(class_124.field_1065 + "TechReborn Developer"));
			}
		});
	}

	private static void addHead(String name) {
		class_1799 head = new class_1799(class_1802.field_8575, 3);
		head.method_7980(new class_2487());
		head.method_7969().method_10566("SkullOwner", class_2519.method_23256(name));
		devHeads.add(head);
	}

}
